package com.example.nan_scan;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Build;
import android.os.VibrationEffect;
import android.os.Vibrator;

import androidx.annotation.NonNull;
import org.jetbrains.annotations.NotNull;
import androidx.lifecycle.Lifecycle;

import java.lang.ref.WeakReference;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.embedding.engine.plugins.lifecycle.FlutterLifecycleAdapter;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;

import static android.content.Context.VIBRATOR_SERVICE;

public class NanScanPlugin2 implements FlutterPlugin, ActivityAware {
    private static final String VIEW_TYPE = "com.scan.widget";
    private FlutterPluginBinding pluginBinding;
    private Activity activity;
//    private QrCodeAsyncTask task;
//    private Result _result;

    @Override
    public void onAttachedToEngine(@NonNull @org.jetbrains.annotations.NotNull FlutterPlugin.FlutterPluginBinding binding) {
        this.pluginBinding = binding;

    }

    private void configChannel(ActivityPluginBinding binding) {
        activity = binding.getActivity();
//        channel = new MethodChannel(pluginBinding.getBinaryMessenger(), "chavesgu/scan");
//        channel.setMethodCallHandler(this);
        pluginBinding.getPlatformViewRegistry()
                .registerViewFactory(VIEW_TYPE, new NanScanFactory(
                        pluginBinding.getBinaryMessenger(),
                        pluginBinding.getApplicationContext(),
                        activity,
                        binding
                ));
    }

    @Override
    public void onDetachedFromEngine(@NonNull @org.jetbrains.annotations.NotNull FlutterPlugin.FlutterPluginBinding binding) {
        pluginBinding = null;
    }

    @Override
    public void onAttachedToActivity(@NonNull @org.jetbrains.annotations.NotNull ActivityPluginBinding binding) {
        configChannel(binding);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
//        this.onDetachedFromActivity();
    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull @org.jetbrains.annotations.NotNull ActivityPluginBinding binding) {
//        onAttachedToActivity(binding);
        configChannel(binding);
    }

    @Override
    public void onDetachedFromActivity() {
        activity = null;
//        channel.setMethodCallHandler(null);
    }

//    @Override
//    public void onMethodCall(@NonNull @NotNull MethodCall call, @NonNull @NotNull Result result) {
//        String path = (String) call.arguments;
//        task = new QrCodeAsyncTask(this, path);
//        task.execute(path);
//    }

    /**
     * AsyncTask 静态内部类，防止内存泄漏
     */
//    static class QrCodeAsyncTask extends AsyncTask<String, Integer, String> {
//        private final WeakReference<NanScanPlugin2> mWeakReference;
//        private final String path;
//
//        public QrCodeAsyncTask(NanScanPlugin2 plugin, String path) {
//            mWeakReference = new WeakReference<>(plugin);
//            this.path = path;
//        }
//
//        @Override
//        protected String doInBackground(String... strings) {
//            // 解析二维码/条码
////            return QRCodeDecoder.decodeQRCode(mWeakReference.get().pluginBinding.getApplicationContext(), path);
//            return "123";
//        }
//
//        @Override
//        protected void onPostExecute(String s) {
//            super.onPostExecute(s);
//            //识别出图片二维码/条码，内容为s
//            NanScanPlugin2 plugin = (NanScanPlugin2) mWeakReference.get();
//            plugin._result.success(s);
//            plugin.task.cancel(true);
//            plugin.task = null;
//            if (s!=null) {
//                Vibrator myVib = (Vibrator) plugin.pluginBinding.getApplicationContext().getSystemService(VIBRATOR_SERVICE);
//                if (myVib != null) {
//                    if (Build.VERSION.SDK_INT >= 26) {
//                        myVib.vibrate(VibrationEffect.createOneShot(50, VibrationEffect.DEFAULT_AMPLITUDE));
//                    } else {
//                        myVib.vibrate(50);
//                    }
//                }
//            }
//        }
//    }
}
